#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityTimeShopCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityTimeShopCFG> M_ActivityTimeShopCFG::msSingleton(nullptr);

int M_ActivityTimeShopCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityTimeShopCFGData* M_ActivityTimeShopCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityTimeShopCFGData>& M_ActivityTimeShopCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityTimeShopCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityTimeShopCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityTimeShopCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* ItemIDs = element->Attribute("ItemIDs");
			std::vector<std::string> vecItemIDs;
			boost::split(vecItemIDs, ItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemIDs[i].c_str(), &temp))
				{
					data.mItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* ItemCounts = element->Attribute("ItemCounts");
			std::vector<std::string> vecItemCounts;
			boost::split(vecItemCounts, ItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCounts[i].c_str(), &temp))
				{
					data.mItemCounts.push_back(temp);
				}
			}
		}
		data.mweight = element->IntAttribute("weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityTimeShopCFG::Load()
{
	Load("../Config/M_ActivityTimeShopCFG.xml");
}

M_ActivityTimeShopCFG* M_ActivityTimeShopCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityTimeShopCFG());
	}
	return msSingleton.get();
}
